<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'FullmaktForetak' => '\\StructType\\FullmaktForetak',
            'FullmaktPerson' => '\\StructType\\FullmaktPerson',
            'VervData' => '\\StructType\\VervData',
            'Scoring' => '\\StructType\\Scoring',
            'ArsaksData' => '\\StructType\\ArsaksData',
            'Scorevariabel' => '\\StructType\\Scorevariabel',
            'Juridisk' => '\\StructType\\Juridisk',
            'Identifikasjon' => '\\StructType\\Identifikasjon',
            'Verv' => '\\StructType\\Verv',
            'BetaKilder' => '\\StructType\\BetaKilder',
            'BetaSammendrag' => '\\StructType\\BetaSammendrag',
            'GjenpartData' => '\\StructType\\GjenpartData',
            'LigningGjenpart' => '\\StructType\\LigningGjenpart',
            'OmspurtData' => '\\StructType\\OmspurtData',
            'BetaOmspurtDetaljer' => '\\StructType\\BetaOmspurtDetaljer',
            'NaringsInteresserGjenpart' => '\\StructType\\NaringsInteresserGjenpart',
            'Meldinger' => '\\StructType\\Meldinger',
            'HistoriskRating' => '\\StructType\\HistoriskRating',
            'NokkeltallForetak' => '\\StructType\\NokkeltallForetak',
            'NokkeltallKonsern' => '\\StructType\\NokkeltallKonsern',
            'NokkeltallBransje' => '\\StructType\\NokkeltallBransje',
            'EiendelerKonsern' => '\\StructType\\EiendelerKonsern',
            'EiendelerForetak' => '\\StructType\\EiendelerForetak',
            'OkonomiSammendragKonsern' => '\\StructType\\OkonomiSammendragKonsern',
            'OkonomiEnk' => '\\StructType\\OkonomiEnk',
            'EiendomNorgeListe' => '\\StructType\\EiendomNorgeListe',
            'Losore' => '\\StructType\\Losore',
            'OkonomiSammendragForetak' => '\\StructType\\OkonomiSammendragForetak',
            'ForetakSok' => '\\StructType\\ForetakSok',
            'AnsatteData' => '\\StructType\\AnsatteData',
            'BransjeData' => '\\StructType\\BransjeData',
            'RegnskapsforerData' => '\\StructType\\RegnskapsforerData',
            'ForetakSokResponse' => '\\StructType\\ForetakSokResponse',
            'Aksjonar' => '\\StructType\\Aksjonar',
            'Rettighetshavere' => '\\StructType\\Rettighetshavere',
            'OvervakningListe' => '\\StructType\\OvervakningListe',
            'OppdaterOvervakningPortefoljeResponse' => '\\StructType\\OppdaterOvervakningPortefoljeResponse',
            'Tilleggsinfo' => '\\StructType\\Tilleggsinfo',
            'HentOvervakningEndringerResponse' => '\\StructType\\HentOvervakningEndringerResponse',
            'Datterselskap' => '\\StructType\\Datterselskap',
            'NavnAdresse' => '\\StructType\\NavnAdresse',
            'HistoriskNavnData' => '\\StructType\\HistoriskNavnData',
            'EiendomNorge' => '\\StructType\\EiendomNorge',
            'OvervakningEndringer' => '\\StructType\\OvervakningEndringer',
            'OppdaterOvervakningPortefolje' => '\\StructType\\OppdaterOvervakningPortefolje',
            'HentOvervakningEndringer' => '\\StructType\\HentOvervakningEndringer',
            'ForetakData' => '\\StructType\\ForetakData',
            'OkonomiDetaljerForetak' => '\\StructType\\OkonomiDetaljerForetak',
            'OkonomiDetaljerKonsern' => '\\StructType\\OkonomiDetaljerKonsern',
            'GjeldEgenkapitalForetak' => '\\StructType\\GjeldEgenkapitalForetak',
            'GjeldEgenkapitalKonsern' => '\\StructType\\GjeldEgenkapitalKonsern',
            'Revisoranmerkning' => '\\StructType\\Revisoranmerkning',
            'KonsernLink' => '\\StructType\\KonsernLink',
            'Kreditorvarsel' => '\\StructType\\Kreditorvarsel',
            'AvdelingData' => '\\StructType\\AvdelingData',
            'HentForetakResponse' => '\\StructType\\HentForetakResponse',
            'Grunnfakta' => '\\StructType\\Grunnfakta',
            'BetaDetaljer' => '\\StructType\\BetaDetaljer',
            'HentForetak' => '\\StructType\\HentForetak',
            'Rating' => '\\StructType\\Rating',
            'HentArsrapportListe' => '\\StructType\\HentArsrapportListe',
            'Regnskapsar' => '\\StructType\\Regnskapsar',
            'HentArsrapportListeResponse' => '\\StructType\\HentArsrapportListeResponse',
            'ArsrapportData' => '\\StructType\\ArsrapportData',
            'HentArsrapport' => '\\StructType\\HentArsrapport',
            'ArsrapportStatus' => '\\StructType\\ArsrapportStatus',
            'HentArsrapportResponse' => '\\StructType\\HentArsrapportResponse',
            'Testinfo' => '\\StructType\\Testinfo',
            'Gjenpart' => '\\StructType\\Gjenpart',
            'BrukerAutorisasjon' => '\\StructType\\BrukerAutorisasjon',
            'ProduserElektroniskGjenpartData' => '\\StructType\\ProduserElektroniskGjenpartData',
        );
    }
}
