<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AnsatteData StructType
 * @subpackage Structs
 */
class AnsatteData extends AbstractStructBase
{
    /**
     * The AnsatteAr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AnsatteAr;
    /**
     * The AnsatteAntall
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AnsatteAntall;
    /**
     * Constructor method for AnsatteData
     * @uses AnsatteData::setAnsatteAr()
     * @uses AnsatteData::setAnsatteAntall()
     * @param int $ansatteAr
     * @param int $ansatteAntall
     */
    public function __construct($ansatteAr = 0, $ansatteAntall = 0)
    {
        $this
            ->setAnsatteAr($ansatteAr)
            ->setAnsatteAntall($ansatteAntall);
    }
    /**
     * Get AnsatteAr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAnsatteAr()
    {
        return isset($this->AnsatteAr) ? $this->AnsatteAr : null;
    }
    /**
     * Set AnsatteAr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $ansatteAr
     * @return \StructType\AnsatteData
     */
    public function setAnsatteAr($ansatteAr = 0)
    {
        // validation for constraint: int
        if (!is_null($ansatteAr) && !is_numeric($ansatteAr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ansatteAr)), __LINE__);
        }
        if (is_null($ansatteAr) || (is_array($ansatteAr) && empty($ansatteAr))) {
            unset($this->AnsatteAr);
        } else {
            $this->AnsatteAr = $ansatteAr;
        }
        return $this;
    }
    /**
     * Get AnsatteAntall value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAnsatteAntall()
    {
        return isset($this->AnsatteAntall) ? $this->AnsatteAntall : null;
    }
    /**
     * Set AnsatteAntall value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $ansatteAntall
     * @return \StructType\AnsatteData
     */
    public function setAnsatteAntall($ansatteAntall = 0)
    {
        // validation for constraint: int
        if (!is_null($ansatteAntall) && !is_numeric($ansatteAntall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ansatteAntall)), __LINE__);
        }
        if (is_null($ansatteAntall) || (is_array($ansatteAntall) && empty($ansatteAntall))) {
            unset($this->AnsatteAntall);
        } else {
            $this->AnsatteAntall = $ansatteAntall;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AnsatteData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
