<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BetaDetaljer StructType
 * @subpackage Structs
 */
class BetaDetaljer extends AbstractStructBase
{
    /**
     * The RegistrertDato
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RegistrertDato;
    /**
     * The BetaGruppeKode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BetaGruppeKode;
    /**
     * The BetaGruppeTekst
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BetaGruppeTekst;
    /**
     * The BetaType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BetaType;
    /**
     * The BetaTekst
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BetaTekst;
    /**
     * The BetaBelop
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $BetaBelop;
    /**
     * The KildeKode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KildeKode;
    /**
     * The KildeTekst
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KildeTekst;
    /**
     * The KildeReferansenr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KildeReferansenr;
    /**
     * The StatusAnmerkning
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StatusAnmerkning;
    /**
     * The StatusDato
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StatusDato;
    /**
     * The Kreditor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Kreditor;
    /**
     * Constructor method for BetaDetaljer
     * @uses BetaDetaljer::setRegistrertDato()
     * @uses BetaDetaljer::setBetaGruppeKode()
     * @uses BetaDetaljer::setBetaGruppeTekst()
     * @uses BetaDetaljer::setBetaType()
     * @uses BetaDetaljer::setBetaTekst()
     * @uses BetaDetaljer::setBetaBelop()
     * @uses BetaDetaljer::setKildeKode()
     * @uses BetaDetaljer::setKildeTekst()
     * @uses BetaDetaljer::setKildeReferansenr()
     * @uses BetaDetaljer::setStatusAnmerkning()
     * @uses BetaDetaljer::setStatusDato()
     * @uses BetaDetaljer::setKreditor()
     * @param string $registrertDato
     * @param string $betaGruppeKode
     * @param string $betaGruppeTekst
     * @param string $betaType
     * @param string $betaTekst
     * @param int $betaBelop
     * @param string $kildeKode
     * @param string $kildeTekst
     * @param string $kildeReferansenr
     * @param string $statusAnmerkning
     * @param string $statusDato
     * @param string $kreditor
     */
    public function __construct($registrertDato = '0001-01-01', $betaGruppeKode = null, $betaGruppeTekst = null, $betaType = null, $betaTekst = null, $betaBelop = 0, $kildeKode = null, $kildeTekst = null, $kildeReferansenr = '0', $statusAnmerkning = null, $statusDato = '0001-01-01', $kreditor = null)
    {
        $this
            ->setRegistrertDato($registrertDato)
            ->setBetaGruppeKode($betaGruppeKode)
            ->setBetaGruppeTekst($betaGruppeTekst)
            ->setBetaType($betaType)
            ->setBetaTekst($betaTekst)
            ->setBetaBelop($betaBelop)
            ->setKildeKode($kildeKode)
            ->setKildeTekst($kildeTekst)
            ->setKildeReferansenr($kildeReferansenr)
            ->setStatusAnmerkning($statusAnmerkning)
            ->setStatusDato($statusDato)
            ->setKreditor($kreditor);
    }
    /**
     * Get RegistrertDato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegistrertDato()
    {
        return isset($this->RegistrertDato) ? $this->RegistrertDato : null;
    }
    /**
     * Set RegistrertDato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $registrertDato
     * @return \StructType\BetaDetaljer
     */
    public function setRegistrertDato($registrertDato = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($registrertDato) && !is_string($registrertDato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($registrertDato)), __LINE__);
        }
        if (is_null($registrertDato) || (is_array($registrertDato) && empty($registrertDato))) {
            unset($this->RegistrertDato);
        } else {
            $this->RegistrertDato = $registrertDato;
        }
        return $this;
    }
    /**
     * Get BetaGruppeKode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBetaGruppeKode()
    {
        return isset($this->BetaGruppeKode) ? $this->BetaGruppeKode : null;
    }
    /**
     * Set BetaGruppeKode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $betaGruppeKode
     * @return \StructType\BetaDetaljer
     */
    public function setBetaGruppeKode($betaGruppeKode = null)
    {
        // validation for constraint: string
        if (!is_null($betaGruppeKode) && !is_string($betaGruppeKode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($betaGruppeKode)), __LINE__);
        }
        if (is_null($betaGruppeKode) || (is_array($betaGruppeKode) && empty($betaGruppeKode))) {
            unset($this->BetaGruppeKode);
        } else {
            $this->BetaGruppeKode = $betaGruppeKode;
        }
        return $this;
    }
    /**
     * Get BetaGruppeTekst value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBetaGruppeTekst()
    {
        return isset($this->BetaGruppeTekst) ? $this->BetaGruppeTekst : null;
    }
    /**
     * Set BetaGruppeTekst value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $betaGruppeTekst
     * @return \StructType\BetaDetaljer
     */
    public function setBetaGruppeTekst($betaGruppeTekst = null)
    {
        // validation for constraint: string
        if (!is_null($betaGruppeTekst) && !is_string($betaGruppeTekst)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($betaGruppeTekst)), __LINE__);
        }
        if (is_null($betaGruppeTekst) || (is_array($betaGruppeTekst) && empty($betaGruppeTekst))) {
            unset($this->BetaGruppeTekst);
        } else {
            $this->BetaGruppeTekst = $betaGruppeTekst;
        }
        return $this;
    }
    /**
     * Get BetaType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBetaType()
    {
        return isset($this->BetaType) ? $this->BetaType : null;
    }
    /**
     * Set BetaType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $betaType
     * @return \StructType\BetaDetaljer
     */
    public function setBetaType($betaType = null)
    {
        // validation for constraint: string
        if (!is_null($betaType) && !is_string($betaType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($betaType)), __LINE__);
        }
        if (is_null($betaType) || (is_array($betaType) && empty($betaType))) {
            unset($this->BetaType);
        } else {
            $this->BetaType = $betaType;
        }
        return $this;
    }
    /**
     * Get BetaTekst value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBetaTekst()
    {
        return isset($this->BetaTekst) ? $this->BetaTekst : null;
    }
    /**
     * Set BetaTekst value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $betaTekst
     * @return \StructType\BetaDetaljer
     */
    public function setBetaTekst($betaTekst = null)
    {
        // validation for constraint: string
        if (!is_null($betaTekst) && !is_string($betaTekst)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($betaTekst)), __LINE__);
        }
        if (is_null($betaTekst) || (is_array($betaTekst) && empty($betaTekst))) {
            unset($this->BetaTekst);
        } else {
            $this->BetaTekst = $betaTekst;
        }
        return $this;
    }
    /**
     * Get BetaBelop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getBetaBelop()
    {
        return isset($this->BetaBelop) ? $this->BetaBelop : null;
    }
    /**
     * Set BetaBelop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $betaBelop
     * @return \StructType\BetaDetaljer
     */
    public function setBetaBelop($betaBelop = 0)
    {
        // validation for constraint: int
        if (!is_null($betaBelop) && !is_numeric($betaBelop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($betaBelop)), __LINE__);
        }
        if (is_null($betaBelop) || (is_array($betaBelop) && empty($betaBelop))) {
            unset($this->BetaBelop);
        } else {
            $this->BetaBelop = $betaBelop;
        }
        return $this;
    }
    /**
     * Get KildeKode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKildeKode()
    {
        return isset($this->KildeKode) ? $this->KildeKode : null;
    }
    /**
     * Set KildeKode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kildeKode
     * @return \StructType\BetaDetaljer
     */
    public function setKildeKode($kildeKode = null)
    {
        // validation for constraint: string
        if (!is_null($kildeKode) && !is_string($kildeKode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kildeKode)), __LINE__);
        }
        if (is_null($kildeKode) || (is_array($kildeKode) && empty($kildeKode))) {
            unset($this->KildeKode);
        } else {
            $this->KildeKode = $kildeKode;
        }
        return $this;
    }
    /**
     * Get KildeTekst value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKildeTekst()
    {
        return isset($this->KildeTekst) ? $this->KildeTekst : null;
    }
    /**
     * Set KildeTekst value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kildeTekst
     * @return \StructType\BetaDetaljer
     */
    public function setKildeTekst($kildeTekst = null)
    {
        // validation for constraint: string
        if (!is_null($kildeTekst) && !is_string($kildeTekst)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kildeTekst)), __LINE__);
        }
        if (is_null($kildeTekst) || (is_array($kildeTekst) && empty($kildeTekst))) {
            unset($this->KildeTekst);
        } else {
            $this->KildeTekst = $kildeTekst;
        }
        return $this;
    }
    /**
     * Get KildeReferansenr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKildeReferansenr()
    {
        return isset($this->KildeReferansenr) ? $this->KildeReferansenr : null;
    }
    /**
     * Set KildeReferansenr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kildeReferansenr
     * @return \StructType\BetaDetaljer
     */
    public function setKildeReferansenr($kildeReferansenr = '0')
    {
        // validation for constraint: string
        if (!is_null($kildeReferansenr) && !is_string($kildeReferansenr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kildeReferansenr)), __LINE__);
        }
        if (is_null($kildeReferansenr) || (is_array($kildeReferansenr) && empty($kildeReferansenr))) {
            unset($this->KildeReferansenr);
        } else {
            $this->KildeReferansenr = $kildeReferansenr;
        }
        return $this;
    }
    /**
     * Get StatusAnmerkning value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatusAnmerkning()
    {
        return isset($this->StatusAnmerkning) ? $this->StatusAnmerkning : null;
    }
    /**
     * Set StatusAnmerkning value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $statusAnmerkning
     * @return \StructType\BetaDetaljer
     */
    public function setStatusAnmerkning($statusAnmerkning = null)
    {
        // validation for constraint: string
        if (!is_null($statusAnmerkning) && !is_string($statusAnmerkning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($statusAnmerkning)), __LINE__);
        }
        if (is_null($statusAnmerkning) || (is_array($statusAnmerkning) && empty($statusAnmerkning))) {
            unset($this->StatusAnmerkning);
        } else {
            $this->StatusAnmerkning = $statusAnmerkning;
        }
        return $this;
    }
    /**
     * Get StatusDato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatusDato()
    {
        return isset($this->StatusDato) ? $this->StatusDato : null;
    }
    /**
     * Set StatusDato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $statusDato
     * @return \StructType\BetaDetaljer
     */
    public function setStatusDato($statusDato = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($statusDato) && !is_string($statusDato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($statusDato)), __LINE__);
        }
        if (is_null($statusDato) || (is_array($statusDato) && empty($statusDato))) {
            unset($this->StatusDato);
        } else {
            $this->StatusDato = $statusDato;
        }
        return $this;
    }
    /**
     * Get Kreditor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKreditor()
    {
        return isset($this->Kreditor) ? $this->Kreditor : null;
    }
    /**
     * Set Kreditor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kreditor
     * @return \StructType\BetaDetaljer
     */
    public function setKreditor($kreditor = null)
    {
        // validation for constraint: string
        if (!is_null($kreditor) && !is_string($kreditor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kreditor)), __LINE__);
        }
        if (is_null($kreditor) || (is_array($kreditor) && empty($kreditor))) {
            unset($this->Kreditor);
        } else {
            $this->Kreditor = $kreditor;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BetaDetaljer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
