<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BetaOmspurtDetaljer StructType
 * @subpackage Structs
 */
class BetaOmspurtDetaljer extends AbstractStructBase
{
    /**
     * The BetaDetaljerPerson
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BetaDetaljer[]
     */
    public $BetaDetaljerPerson;
    /**
     * The BetaDetaljerEnk
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BetaDetaljer[]
     */
    public $BetaDetaljerEnk;
    /**
     * The BetaKilder
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BetaKilder[]
     */
    public $BetaKilder;
    /**
     * Constructor method for BetaOmspurtDetaljer
     * @uses BetaOmspurtDetaljer::setBetaDetaljerPerson()
     * @uses BetaOmspurtDetaljer::setBetaDetaljerEnk()
     * @uses BetaOmspurtDetaljer::setBetaKilder()
     * @param \StructType\BetaDetaljer[] $betaDetaljerPerson
     * @param \StructType\BetaDetaljer[] $betaDetaljerEnk
     * @param \StructType\BetaKilder[] $betaKilder
     */
    public function __construct(array $betaDetaljerPerson = array(), array $betaDetaljerEnk = array(), array $betaKilder = array())
    {
        $this
            ->setBetaDetaljerPerson($betaDetaljerPerson)
            ->setBetaDetaljerEnk($betaDetaljerEnk)
            ->setBetaKilder($betaKilder);
    }
    /**
     * Get BetaDetaljerPerson value
     * @return \StructType\BetaDetaljer[]|null
     */
    public function getBetaDetaljerPerson()
    {
        return $this->BetaDetaljerPerson;
    }
    /**
     * Set BetaDetaljerPerson value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaDetaljer[] $betaDetaljerPerson
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function setBetaDetaljerPerson(array $betaDetaljerPerson = array())
    {
        foreach ($betaDetaljerPerson as $betaOmspurtDetaljerBetaDetaljerPersonItem) {
            // validation for constraint: itemType
            if (!$betaOmspurtDetaljerBetaDetaljerPersonItem instanceof \StructType\BetaDetaljer) {
                throw new \InvalidArgumentException(sprintf('The BetaDetaljerPerson property can only contain items of \StructType\BetaDetaljer, "%s" given', is_object($betaOmspurtDetaljerBetaDetaljerPersonItem) ? get_class($betaOmspurtDetaljerBetaDetaljerPersonItem) : gettype($betaOmspurtDetaljerBetaDetaljerPersonItem)), __LINE__);
            }
        }
        $this->BetaDetaljerPerson = $betaDetaljerPerson;
        return $this;
    }
    /**
     * Add item to BetaDetaljerPerson value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaDetaljer $item
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function addToBetaDetaljerPerson(\StructType\BetaDetaljer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BetaDetaljer) {
            throw new \InvalidArgumentException(sprintf('The BetaDetaljerPerson property can only contain items of \StructType\BetaDetaljer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BetaDetaljerPerson[] = $item;
        return $this;
    }
    /**
     * Get BetaDetaljerEnk value
     * @return \StructType\BetaDetaljer[]|null
     */
    public function getBetaDetaljerEnk()
    {
        return $this->BetaDetaljerEnk;
    }
    /**
     * Set BetaDetaljerEnk value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaDetaljer[] $betaDetaljerEnk
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function setBetaDetaljerEnk(array $betaDetaljerEnk = array())
    {
        foreach ($betaDetaljerEnk as $betaOmspurtDetaljerBetaDetaljerEnkItem) {
            // validation for constraint: itemType
            if (!$betaOmspurtDetaljerBetaDetaljerEnkItem instanceof \StructType\BetaDetaljer) {
                throw new \InvalidArgumentException(sprintf('The BetaDetaljerEnk property can only contain items of \StructType\BetaDetaljer, "%s" given', is_object($betaOmspurtDetaljerBetaDetaljerEnkItem) ? get_class($betaOmspurtDetaljerBetaDetaljerEnkItem) : gettype($betaOmspurtDetaljerBetaDetaljerEnkItem)), __LINE__);
            }
        }
        $this->BetaDetaljerEnk = $betaDetaljerEnk;
        return $this;
    }
    /**
     * Add item to BetaDetaljerEnk value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaDetaljer $item
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function addToBetaDetaljerEnk(\StructType\BetaDetaljer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BetaDetaljer) {
            throw new \InvalidArgumentException(sprintf('The BetaDetaljerEnk property can only contain items of \StructType\BetaDetaljer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BetaDetaljerEnk[] = $item;
        return $this;
    }
    /**
     * Get BetaKilder value
     * @return \StructType\BetaKilder[]|null
     */
    public function getBetaKilder()
    {
        return $this->BetaKilder;
    }
    /**
     * Set BetaKilder value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaKilder[] $betaKilder
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function setBetaKilder(array $betaKilder = array())
    {
        foreach ($betaKilder as $betaOmspurtDetaljerBetaKilderItem) {
            // validation for constraint: itemType
            if (!$betaOmspurtDetaljerBetaKilderItem instanceof \StructType\BetaKilder) {
                throw new \InvalidArgumentException(sprintf('The BetaKilder property can only contain items of \StructType\BetaKilder, "%s" given', is_object($betaOmspurtDetaljerBetaKilderItem) ? get_class($betaOmspurtDetaljerBetaKilderItem) : gettype($betaOmspurtDetaljerBetaKilderItem)), __LINE__);
            }
        }
        $this->BetaKilder = $betaKilder;
        return $this;
    }
    /**
     * Add item to BetaKilder value
     * @throws \InvalidArgumentException
     * @param \StructType\BetaKilder $item
     * @return \StructType\BetaOmspurtDetaljer
     */
    public function addToBetaKilder(\StructType\BetaKilder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BetaKilder) {
            throw new \InvalidArgumentException(sprintf('The BetaKilder property can only contain items of \StructType\BetaKilder, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BetaKilder[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BetaOmspurtDetaljer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
