<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BetaSammendrag StructType
 * @subpackage Structs
 */
class BetaSammendrag extends AbstractStructBase
{
    /**
     * The AntallInkasso
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AntallInkasso;
    /**
     * The AjourDatoInkasso
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AjourDatoInkasso;
    /**
     * The AntallPanterLosore
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AntallPanterLosore;
    /**
     * The AjourDatoLosore
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AjourDatoLosore;
    /**
     * The AntallPanterEiendom
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AntallPanterEiendom;
    /**
     * The AjourDatoEiendom
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AjourDatoEiendom;
    /**
     * Constructor method for BetaSammendrag
     * @uses BetaSammendrag::setAntallInkasso()
     * @uses BetaSammendrag::setAjourDatoInkasso()
     * @uses BetaSammendrag::setAntallPanterLosore()
     * @uses BetaSammendrag::setAjourDatoLosore()
     * @uses BetaSammendrag::setAntallPanterEiendom()
     * @uses BetaSammendrag::setAjourDatoEiendom()
     * @param int $antallInkasso
     * @param string $ajourDatoInkasso
     * @param int $antallPanterLosore
     * @param string $ajourDatoLosore
     * @param int $antallPanterEiendom
     * @param string $ajourDatoEiendom
     */
    public function __construct($antallInkasso = 0, $ajourDatoInkasso = '0001-01-01', $antallPanterLosore = 0, $ajourDatoLosore = '0001-01-01', $antallPanterEiendom = 0, $ajourDatoEiendom = '0001-01-01')
    {
        $this
            ->setAntallInkasso($antallInkasso)
            ->setAjourDatoInkasso($ajourDatoInkasso)
            ->setAntallPanterLosore($antallPanterLosore)
            ->setAjourDatoLosore($ajourDatoLosore)
            ->setAntallPanterEiendom($antallPanterEiendom)
            ->setAjourDatoEiendom($ajourDatoEiendom);
    }
    /**
     * Get AntallInkasso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAntallInkasso()
    {
        return isset($this->AntallInkasso) ? $this->AntallInkasso : null;
    }
    /**
     * Set AntallInkasso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $antallInkasso
     * @return \StructType\BetaSammendrag
     */
    public function setAntallInkasso($antallInkasso = 0)
    {
        // validation for constraint: int
        if (!is_null($antallInkasso) && !is_numeric($antallInkasso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($antallInkasso)), __LINE__);
        }
        if (is_null($antallInkasso) || (is_array($antallInkasso) && empty($antallInkasso))) {
            unset($this->AntallInkasso);
        } else {
            $this->AntallInkasso = $antallInkasso;
        }
        return $this;
    }
    /**
     * Get AjourDatoInkasso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAjourDatoInkasso()
    {
        return isset($this->AjourDatoInkasso) ? $this->AjourDatoInkasso : null;
    }
    /**
     * Set AjourDatoInkasso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ajourDatoInkasso
     * @return \StructType\BetaSammendrag
     */
    public function setAjourDatoInkasso($ajourDatoInkasso = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($ajourDatoInkasso) && !is_string($ajourDatoInkasso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ajourDatoInkasso)), __LINE__);
        }
        if (is_null($ajourDatoInkasso) || (is_array($ajourDatoInkasso) && empty($ajourDatoInkasso))) {
            unset($this->AjourDatoInkasso);
        } else {
            $this->AjourDatoInkasso = $ajourDatoInkasso;
        }
        return $this;
    }
    /**
     * Get AntallPanterLosore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAntallPanterLosore()
    {
        return isset($this->AntallPanterLosore) ? $this->AntallPanterLosore : null;
    }
    /**
     * Set AntallPanterLosore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $antallPanterLosore
     * @return \StructType\BetaSammendrag
     */
    public function setAntallPanterLosore($antallPanterLosore = 0)
    {
        // validation for constraint: int
        if (!is_null($antallPanterLosore) && !is_numeric($antallPanterLosore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($antallPanterLosore)), __LINE__);
        }
        if (is_null($antallPanterLosore) || (is_array($antallPanterLosore) && empty($antallPanterLosore))) {
            unset($this->AntallPanterLosore);
        } else {
            $this->AntallPanterLosore = $antallPanterLosore;
        }
        return $this;
    }
    /**
     * Get AjourDatoLosore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAjourDatoLosore()
    {
        return isset($this->AjourDatoLosore) ? $this->AjourDatoLosore : null;
    }
    /**
     * Set AjourDatoLosore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ajourDatoLosore
     * @return \StructType\BetaSammendrag
     */
    public function setAjourDatoLosore($ajourDatoLosore = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($ajourDatoLosore) && !is_string($ajourDatoLosore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ajourDatoLosore)), __LINE__);
        }
        if (is_null($ajourDatoLosore) || (is_array($ajourDatoLosore) && empty($ajourDatoLosore))) {
            unset($this->AjourDatoLosore);
        } else {
            $this->AjourDatoLosore = $ajourDatoLosore;
        }
        return $this;
    }
    /**
     * Get AntallPanterEiendom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAntallPanterEiendom()
    {
        return isset($this->AntallPanterEiendom) ? $this->AntallPanterEiendom : null;
    }
    /**
     * Set AntallPanterEiendom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $antallPanterEiendom
     * @return \StructType\BetaSammendrag
     */
    public function setAntallPanterEiendom($antallPanterEiendom = 0)
    {
        // validation for constraint: int
        if (!is_null($antallPanterEiendom) && !is_numeric($antallPanterEiendom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($antallPanterEiendom)), __LINE__);
        }
        if (is_null($antallPanterEiendom) || (is_array($antallPanterEiendom) && empty($antallPanterEiendom))) {
            unset($this->AntallPanterEiendom);
        } else {
            $this->AntallPanterEiendom = $antallPanterEiendom;
        }
        return $this;
    }
    /**
     * Get AjourDatoEiendom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAjourDatoEiendom()
    {
        return isset($this->AjourDatoEiendom) ? $this->AjourDatoEiendom : null;
    }
    /**
     * Set AjourDatoEiendom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ajourDatoEiendom
     * @return \StructType\BetaSammendrag
     */
    public function setAjourDatoEiendom($ajourDatoEiendom = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($ajourDatoEiendom) && !is_string($ajourDatoEiendom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ajourDatoEiendom)), __LINE__);
        }
        if (is_null($ajourDatoEiendom) || (is_array($ajourDatoEiendom) && empty($ajourDatoEiendom))) {
            unset($this->AjourDatoEiendom);
        } else {
            $this->AjourDatoEiendom = $ajourDatoEiendom;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BetaSammendrag
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
