<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HentArsrapportListeResponse StructType
 * @subpackage Structs
 */
class HentArsrapportListeResponse extends AbstractStructBase
{
    /**
     * The Meldinger
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\Meldinger[]
     */
    public $Meldinger;
    /**
     * The ArsrapportData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ArsrapportData
     */
    public $ArsrapportData;
    /**
     * Constructor method for HentArsrapportListeResponse
     * @uses HentArsrapportListeResponse::setMeldinger()
     * @uses HentArsrapportListeResponse::setArsrapportData()
     * @param \StructType\Meldinger[] $meldinger
     * @param \StructType\ArsrapportData $arsrapportData
     */
    public function __construct(array $meldinger = array(), \StructType\ArsrapportData $arsrapportData = null)
    {
        $this
            ->setMeldinger($meldinger)
            ->setArsrapportData($arsrapportData);
    }
    /**
     * Get Meldinger value
     * @return \StructType\Meldinger[]
     */
    public function getMeldinger()
    {
        return $this->Meldinger;
    }
    /**
     * Set Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger[] $meldinger
     * @return \StructType\HentArsrapportListeResponse
     */
    public function setMeldinger(array $meldinger = array())
    {
        foreach ($meldinger as $hentArsrapportListeResponseMeldingerItem) {
            // validation for constraint: itemType
            if (!$hentArsrapportListeResponseMeldingerItem instanceof \StructType\Meldinger) {
                throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($hentArsrapportListeResponseMeldingerItem) ? get_class($hentArsrapportListeResponseMeldingerItem) : gettype($hentArsrapportListeResponseMeldingerItem)), __LINE__);
            }
        }
        $this->Meldinger = $meldinger;
        return $this;
    }
    /**
     * Add item to Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger $item
     * @return \StructType\HentArsrapportListeResponse
     */
    public function addToMeldinger(\StructType\Meldinger $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Meldinger) {
            throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Meldinger[] = $item;
        return $this;
    }
    /**
     * Get ArsrapportData value
     * @return \StructType\ArsrapportData|null
     */
    public function getArsrapportData()
    {
        return $this->ArsrapportData;
    }
    /**
     * Set ArsrapportData value
     * @param \StructType\ArsrapportData $arsrapportData
     * @return \StructType\HentArsrapportListeResponse
     */
    public function setArsrapportData(\StructType\ArsrapportData $arsrapportData = null)
    {
        $this->ArsrapportData = $arsrapportData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HentArsrapportListeResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
