<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HentOvervakningEndringer StructType
 * @subpackage Structs
 */
class HentOvervakningEndringer extends AbstractStructBase
{
    /**
     * The Dato
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Dato;
    /**
     * The Avdnr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Avdnr;
    /**
     * Constructor method for HentOvervakningEndringer
     * @uses HentOvervakningEndringer::setDato()
     * @uses HentOvervakningEndringer::setAvdnr()
     * @param string $dato
     * @param string $avdnr
     */
    public function __construct($dato = null, $avdnr = null)
    {
        $this
            ->setDato($dato)
            ->setAvdnr($avdnr);
    }
    /**
     * Get Dato value
     * @return string
     */
    public function getDato()
    {
        return $this->Dato;
    }
    /**
     * Set Dato value
     * @param string $dato
     * @return \StructType\HentOvervakningEndringer
     */
    public function setDato($dato = null)
    {
        // validation for constraint: string
        if (!is_null($dato) && !is_string($dato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dato)), __LINE__);
        }
        $this->Dato = $dato;
        return $this;
    }
    /**
     * Get Avdnr value
     * @return string|null
     */
    public function getAvdnr()
    {
        return $this->Avdnr;
    }
    /**
     * Set Avdnr value
     * @param string $avdnr
     * @return \StructType\HentOvervakningEndringer
     */
    public function setAvdnr($avdnr = null)
    {
        // validation for constraint: string
        if (!is_null($avdnr) && !is_string($avdnr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($avdnr)), __LINE__);
        }
        $this->Avdnr = $avdnr;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HentOvervakningEndringer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
