<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HentOvervakningEndringerResponse StructType
 * @subpackage Structs
 */
class HentOvervakningEndringerResponse extends AbstractStructBase
{
    /**
     * The OvervakningEndringer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OvervakningEndringer[]
     */
    public $OvervakningEndringer;
    /**
     * The Meldinger
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Meldinger[]
     */
    public $Meldinger;
    /**
     * Constructor method for HentOvervakningEndringerResponse
     * @uses HentOvervakningEndringerResponse::setOvervakningEndringer()
     * @uses HentOvervakningEndringerResponse::setMeldinger()
     * @param \StructType\OvervakningEndringer[] $overvakningEndringer
     * @param \StructType\Meldinger[] $meldinger
     */
    public function __construct(array $overvakningEndringer = array(), array $meldinger = array())
    {
        $this
            ->setOvervakningEndringer($overvakningEndringer)
            ->setMeldinger($meldinger);
    }
    /**
     * Get OvervakningEndringer value
     * @return \StructType\OvervakningEndringer[]|null
     */
    public function getOvervakningEndringer()
    {
        return $this->OvervakningEndringer;
    }
    /**
     * Set OvervakningEndringer value
     * @throws \InvalidArgumentException
     * @param \StructType\OvervakningEndringer[] $overvakningEndringer
     * @return \StructType\HentOvervakningEndringerResponse
     */
    public function setOvervakningEndringer(array $overvakningEndringer = array())
    {
        foreach ($overvakningEndringer as $hentOvervakningEndringerResponseOvervakningEndringerItem) {
            // validation for constraint: itemType
            if (!$hentOvervakningEndringerResponseOvervakningEndringerItem instanceof \StructType\OvervakningEndringer) {
                throw new \InvalidArgumentException(sprintf('The OvervakningEndringer property can only contain items of \StructType\OvervakningEndringer, "%s" given', is_object($hentOvervakningEndringerResponseOvervakningEndringerItem) ? get_class($hentOvervakningEndringerResponseOvervakningEndringerItem) : gettype($hentOvervakningEndringerResponseOvervakningEndringerItem)), __LINE__);
            }
        }
        $this->OvervakningEndringer = $overvakningEndringer;
        return $this;
    }
    /**
     * Add item to OvervakningEndringer value
     * @throws \InvalidArgumentException
     * @param \StructType\OvervakningEndringer $item
     * @return \StructType\HentOvervakningEndringerResponse
     */
    public function addToOvervakningEndringer(\StructType\OvervakningEndringer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OvervakningEndringer) {
            throw new \InvalidArgumentException(sprintf('The OvervakningEndringer property can only contain items of \StructType\OvervakningEndringer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OvervakningEndringer[] = $item;
        return $this;
    }
    /**
     * Get Meldinger value
     * @return \StructType\Meldinger[]|null
     */
    public function getMeldinger()
    {
        return $this->Meldinger;
    }
    /**
     * Set Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger[] $meldinger
     * @return \StructType\HentOvervakningEndringerResponse
     */
    public function setMeldinger(array $meldinger = array())
    {
        foreach ($meldinger as $hentOvervakningEndringerResponseMeldingerItem) {
            // validation for constraint: itemType
            if (!$hentOvervakningEndringerResponseMeldingerItem instanceof \StructType\Meldinger) {
                throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($hentOvervakningEndringerResponseMeldingerItem) ? get_class($hentOvervakningEndringerResponseMeldingerItem) : gettype($hentOvervakningEndringerResponseMeldingerItem)), __LINE__);
            }
        }
        $this->Meldinger = $meldinger;
        return $this;
    }
    /**
     * Add item to Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger $item
     * @return \StructType\HentOvervakningEndringerResponse
     */
    public function addToMeldinger(\StructType\Meldinger $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Meldinger) {
            throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Meldinger[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HentOvervakningEndringerResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
