<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HistoriskRating StructType
 * @subpackage Structs
 */
class HistoriskRating extends AbstractStructBase
{
    /**
     * The EndrAr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $EndrAr;
    /**
     * The EndrMnd
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $EndrMnd;
    /**
     * The Rating
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Rating;
    /**
     * The Limit
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Limit;
    /**
     * The AktuellHendelse
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AktuellHendelse;
    /**
     * The RegnAr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $RegnAr;
    /**
     * Constructor method for HistoriskRating
     * @uses HistoriskRating::setEndrAr()
     * @uses HistoriskRating::setEndrMnd()
     * @uses HistoriskRating::setRating()
     * @uses HistoriskRating::setLimit()
     * @uses HistoriskRating::setAktuellHendelse()
     * @uses HistoriskRating::setRegnAr()
     * @param int $endrAr
     * @param int $endrMnd
     * @param string $rating
     * @param int $limit
     * @param string $aktuellHendelse
     * @param int $regnAr
     */
    public function __construct($endrAr = 0, $endrMnd = 0, $rating = null, $limit = 0, $aktuellHendelse = null, $regnAr = 0)
    {
        $this
            ->setEndrAr($endrAr)
            ->setEndrMnd($endrMnd)
            ->setRating($rating)
            ->setLimit($limit)
            ->setAktuellHendelse($aktuellHendelse)
            ->setRegnAr($regnAr);
    }
    /**
     * Get EndrAr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getEndrAr()
    {
        return isset($this->EndrAr) ? $this->EndrAr : null;
    }
    /**
     * Set EndrAr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $endrAr
     * @return \StructType\HistoriskRating
     */
    public function setEndrAr($endrAr = 0)
    {
        // validation for constraint: int
        if (!is_null($endrAr) && !is_numeric($endrAr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($endrAr)), __LINE__);
        }
        if (is_null($endrAr) || (is_array($endrAr) && empty($endrAr))) {
            unset($this->EndrAr);
        } else {
            $this->EndrAr = $endrAr;
        }
        return $this;
    }
    /**
     * Get EndrMnd value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getEndrMnd()
    {
        return isset($this->EndrMnd) ? $this->EndrMnd : null;
    }
    /**
     * Set EndrMnd value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $endrMnd
     * @return \StructType\HistoriskRating
     */
    public function setEndrMnd($endrMnd = 0)
    {
        // validation for constraint: int
        if (!is_null($endrMnd) && !is_numeric($endrMnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($endrMnd)), __LINE__);
        }
        if (is_null($endrMnd) || (is_array($endrMnd) && empty($endrMnd))) {
            unset($this->EndrMnd);
        } else {
            $this->EndrMnd = $endrMnd;
        }
        return $this;
    }
    /**
     * Get Rating value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRating()
    {
        return isset($this->Rating) ? $this->Rating : null;
    }
    /**
     * Set Rating value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rating
     * @return \StructType\HistoriskRating
     */
    public function setRating($rating = null)
    {
        // validation for constraint: string
        if (!is_null($rating) && !is_string($rating)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rating)), __LINE__);
        }
        if (is_null($rating) || (is_array($rating) && empty($rating))) {
            unset($this->Rating);
        } else {
            $this->Rating = $rating;
        }
        return $this;
    }
    /**
     * Get Limit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getLimit()
    {
        return isset($this->Limit) ? $this->Limit : null;
    }
    /**
     * Set Limit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $limit
     * @return \StructType\HistoriskRating
     */
    public function setLimit($limit = 0)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        if (is_null($limit) || (is_array($limit) && empty($limit))) {
            unset($this->Limit);
        } else {
            $this->Limit = $limit;
        }
        return $this;
    }
    /**
     * Get AktuellHendelse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAktuellHendelse()
    {
        return isset($this->AktuellHendelse) ? $this->AktuellHendelse : null;
    }
    /**
     * Set AktuellHendelse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $aktuellHendelse
     * @return \StructType\HistoriskRating
     */
    public function setAktuellHendelse($aktuellHendelse = null)
    {
        // validation for constraint: string
        if (!is_null($aktuellHendelse) && !is_string($aktuellHendelse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aktuellHendelse)), __LINE__);
        }
        if (is_null($aktuellHendelse) || (is_array($aktuellHendelse) && empty($aktuellHendelse))) {
            unset($this->AktuellHendelse);
        } else {
            $this->AktuellHendelse = $aktuellHendelse;
        }
        return $this;
    }
    /**
     * Get RegnAr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getRegnAr()
    {
        return isset($this->RegnAr) ? $this->RegnAr : null;
    }
    /**
     * Set RegnAr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $regnAr
     * @return \StructType\HistoriskRating
     */
    public function setRegnAr($regnAr = 0)
    {
        // validation for constraint: int
        if (!is_null($regnAr) && !is_numeric($regnAr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($regnAr)), __LINE__);
        }
        if (is_null($regnAr) || (is_array($regnAr) && empty($regnAr))) {
            unset($this->RegnAr);
        } else {
            $this->RegnAr = $regnAr;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HistoriskRating
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
