<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LigningGjenpart StructType
 * @subpackage Structs
 */
class LigningGjenpart extends AbstractStructBase
{
    /**
     * The SkatteAr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $SkatteAr;
    /**
     * The Formue
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Formue;
    /**
     * The Inntekt
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Inntekt;
    /**
     * The Skatt
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Skatt;
    /**
     * The SkatteKlasse
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SkatteKlasse;
    /**
     * The Kommunenr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kommunenr;
    /**
     * The KommuneNavn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KommuneNavn;
    /**
     * Constructor method for LigningGjenpart
     * @uses LigningGjenpart::setSkatteAr()
     * @uses LigningGjenpart::setFormue()
     * @uses LigningGjenpart::setInntekt()
     * @uses LigningGjenpart::setSkatt()
     * @uses LigningGjenpart::setSkatteKlasse()
     * @uses LigningGjenpart::setKommunenr()
     * @uses LigningGjenpart::setKommuneNavn()
     * @param int $skatteAr
     * @param int $formue
     * @param int $inntekt
     * @param int $skatt
     * @param string $skatteKlasse
     * @param string $kommunenr
     * @param string $kommuneNavn
     */
    public function __construct($skatteAr = 0, $formue = 0, $inntekt = 0, $skatt = 0, $skatteKlasse = null, $kommunenr = null, $kommuneNavn = null)
    {
        $this
            ->setSkatteAr($skatteAr)
            ->setFormue($formue)
            ->setInntekt($inntekt)
            ->setSkatt($skatt)
            ->setSkatteKlasse($skatteKlasse)
            ->setKommunenr($kommunenr)
            ->setKommuneNavn($kommuneNavn);
    }
    /**
     * Get SkatteAr value
     * @return int|null
     */
    public function getSkatteAr()
    {
        return $this->SkatteAr;
    }
    /**
     * Set SkatteAr value
     * @param int $skatteAr
     * @return \StructType\LigningGjenpart
     */
    public function setSkatteAr($skatteAr = 0)
    {
        // validation for constraint: int
        if (!is_null($skatteAr) && !is_numeric($skatteAr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skatteAr)), __LINE__);
        }
        $this->SkatteAr = $skatteAr;
        return $this;
    }
    /**
     * Get Formue value
     * @return int|null
     */
    public function getFormue()
    {
        return $this->Formue;
    }
    /**
     * Set Formue value
     * @param int $formue
     * @return \StructType\LigningGjenpart
     */
    public function setFormue($formue = 0)
    {
        // validation for constraint: int
        if (!is_null($formue) && !is_numeric($formue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($formue)), __LINE__);
        }
        $this->Formue = $formue;
        return $this;
    }
    /**
     * Get Inntekt value
     * @return int|null
     */
    public function getInntekt()
    {
        return $this->Inntekt;
    }
    /**
     * Set Inntekt value
     * @param int $inntekt
     * @return \StructType\LigningGjenpart
     */
    public function setInntekt($inntekt = 0)
    {
        // validation for constraint: int
        if (!is_null($inntekt) && !is_numeric($inntekt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($inntekt)), __LINE__);
        }
        $this->Inntekt = $inntekt;
        return $this;
    }
    /**
     * Get Skatt value
     * @return int|null
     */
    public function getSkatt()
    {
        return $this->Skatt;
    }
    /**
     * Set Skatt value
     * @param int $skatt
     * @return \StructType\LigningGjenpart
     */
    public function setSkatt($skatt = 0)
    {
        // validation for constraint: int
        if (!is_null($skatt) && !is_numeric($skatt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skatt)), __LINE__);
        }
        $this->Skatt = $skatt;
        return $this;
    }
    /**
     * Get SkatteKlasse value
     * @return string|null
     */
    public function getSkatteKlasse()
    {
        return $this->SkatteKlasse;
    }
    /**
     * Set SkatteKlasse value
     * @param string $skatteKlasse
     * @return \StructType\LigningGjenpart
     */
    public function setSkatteKlasse($skatteKlasse = null)
    {
        // validation for constraint: string
        if (!is_null($skatteKlasse) && !is_string($skatteKlasse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($skatteKlasse)), __LINE__);
        }
        $this->SkatteKlasse = $skatteKlasse;
        return $this;
    }
    /**
     * Get Kommunenr value
     * @return string|null
     */
    public function getKommunenr()
    {
        return $this->Kommunenr;
    }
    /**
     * Set Kommunenr value
     * @param string $kommunenr
     * @return \StructType\LigningGjenpart
     */
    public function setKommunenr($kommunenr = null)
    {
        // validation for constraint: string
        if (!is_null($kommunenr) && !is_string($kommunenr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kommunenr)), __LINE__);
        }
        $this->Kommunenr = $kommunenr;
        return $this;
    }
    /**
     * Get KommuneNavn value
     * @return string|null
     */
    public function getKommuneNavn()
    {
        return $this->KommuneNavn;
    }
    /**
     * Set KommuneNavn value
     * @param string $kommuneNavn
     * @return \StructType\LigningGjenpart
     */
    public function setKommuneNavn($kommuneNavn = null)
    {
        // validation for constraint: string
        if (!is_null($kommuneNavn) && !is_string($kommuneNavn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kommuneNavn)), __LINE__);
        }
        $this->KommuneNavn = $kommuneNavn;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LigningGjenpart
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
