<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OkonomiEnk StructType
 * @subpackage Structs
 */
class OkonomiEnk extends AbstractStructBase
{
    /**
     * The FodselsdatoEier
     * Meta informations extracted from the WSDL
     * - default: 0001-01-01
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FodselsdatoEier;
    /**
     * The SkatteAr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $SkatteAr;
    /**
     * The Formue
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Formue;
    /**
     * The EndringFormue
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $EndringFormue;
    /**
     * The Inntekt
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Inntekt;
    /**
     * The EndringInntekt
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $EndringInntekt;
    /**
     * The Skatt
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Skatt;
    /**
     * The SkatteKlasse
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SkatteKlasse;
    /**
     * The SkatteKlasseUtl
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SkatteKlasseUtl;
    /**
     * The Kommunenr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Kommunenr;
    /**
     * The KommuneNavn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KommuneNavn;
    /**
     * Constructor method for OkonomiEnk
     * @uses OkonomiEnk::setFodselsdatoEier()
     * @uses OkonomiEnk::setSkatteAr()
     * @uses OkonomiEnk::setFormue()
     * @uses OkonomiEnk::setEndringFormue()
     * @uses OkonomiEnk::setInntekt()
     * @uses OkonomiEnk::setEndringInntekt()
     * @uses OkonomiEnk::setSkatt()
     * @uses OkonomiEnk::setSkatteKlasse()
     * @uses OkonomiEnk::setSkatteKlasseUtl()
     * @uses OkonomiEnk::setKommunenr()
     * @uses OkonomiEnk::setKommuneNavn()
     * @param string $fodselsdatoEier
     * @param int $skatteAr
     * @param int $formue
     * @param float $endringFormue
     * @param int $inntekt
     * @param float $endringInntekt
     * @param int $skatt
     * @param string $skatteKlasse
     * @param string $skatteKlasseUtl
     * @param int $kommunenr
     * @param string $kommuneNavn
     */
    public function __construct($fodselsdatoEier = '0001-01-01', $skatteAr = 0, $formue = 0, $endringFormue = 0, $inntekt = 0, $endringInntekt = 0, $skatt = 0, $skatteKlasse = '0', $skatteKlasseUtl = '0', $kommunenr = 0, $kommuneNavn = null)
    {
        $this
            ->setFodselsdatoEier($fodselsdatoEier)
            ->setSkatteAr($skatteAr)
            ->setFormue($formue)
            ->setEndringFormue($endringFormue)
            ->setInntekt($inntekt)
            ->setEndringInntekt($endringInntekt)
            ->setSkatt($skatt)
            ->setSkatteKlasse($skatteKlasse)
            ->setSkatteKlasseUtl($skatteKlasseUtl)
            ->setKommunenr($kommunenr)
            ->setKommuneNavn($kommuneNavn);
    }
    /**
     * Get FodselsdatoEier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFodselsdatoEier()
    {
        return isset($this->FodselsdatoEier) ? $this->FodselsdatoEier : null;
    }
    /**
     * Set FodselsdatoEier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fodselsdatoEier
     * @return \StructType\OkonomiEnk
     */
    public function setFodselsdatoEier($fodselsdatoEier = '0001-01-01')
    {
        // validation for constraint: string
        if (!is_null($fodselsdatoEier) && !is_string($fodselsdatoEier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fodselsdatoEier)), __LINE__);
        }
        if (is_null($fodselsdatoEier) || (is_array($fodselsdatoEier) && empty($fodselsdatoEier))) {
            unset($this->FodselsdatoEier);
        } else {
            $this->FodselsdatoEier = $fodselsdatoEier;
        }
        return $this;
    }
    /**
     * Get SkatteAr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSkatteAr()
    {
        return isset($this->SkatteAr) ? $this->SkatteAr : null;
    }
    /**
     * Set SkatteAr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $skatteAr
     * @return \StructType\OkonomiEnk
     */
    public function setSkatteAr($skatteAr = 0)
    {
        // validation for constraint: int
        if (!is_null($skatteAr) && !is_numeric($skatteAr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skatteAr)), __LINE__);
        }
        if (is_null($skatteAr) || (is_array($skatteAr) && empty($skatteAr))) {
            unset($this->SkatteAr);
        } else {
            $this->SkatteAr = $skatteAr;
        }
        return $this;
    }
    /**
     * Get Formue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getFormue()
    {
        return isset($this->Formue) ? $this->Formue : null;
    }
    /**
     * Set Formue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $formue
     * @return \StructType\OkonomiEnk
     */
    public function setFormue($formue = 0)
    {
        // validation for constraint: int
        if (!is_null($formue) && !is_numeric($formue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($formue)), __LINE__);
        }
        if (is_null($formue) || (is_array($formue) && empty($formue))) {
            unset($this->Formue);
        } else {
            $this->Formue = $formue;
        }
        return $this;
    }
    /**
     * Get EndringFormue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getEndringFormue()
    {
        return isset($this->EndringFormue) ? $this->EndringFormue : null;
    }
    /**
     * Set EndringFormue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $endringFormue
     * @return \StructType\OkonomiEnk
     */
    public function setEndringFormue($endringFormue = 0)
    {
        if (is_null($endringFormue) || (is_array($endringFormue) && empty($endringFormue))) {
            unset($this->EndringFormue);
        } else {
            $this->EndringFormue = $endringFormue;
        }
        return $this;
    }
    /**
     * Get Inntekt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getInntekt()
    {
        return isset($this->Inntekt) ? $this->Inntekt : null;
    }
    /**
     * Set Inntekt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $inntekt
     * @return \StructType\OkonomiEnk
     */
    public function setInntekt($inntekt = 0)
    {
        // validation for constraint: int
        if (!is_null($inntekt) && !is_numeric($inntekt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($inntekt)), __LINE__);
        }
        if (is_null($inntekt) || (is_array($inntekt) && empty($inntekt))) {
            unset($this->Inntekt);
        } else {
            $this->Inntekt = $inntekt;
        }
        return $this;
    }
    /**
     * Get EndringInntekt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getEndringInntekt()
    {
        return isset($this->EndringInntekt) ? $this->EndringInntekt : null;
    }
    /**
     * Set EndringInntekt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $endringInntekt
     * @return \StructType\OkonomiEnk
     */
    public function setEndringInntekt($endringInntekt = 0)
    {
        if (is_null($endringInntekt) || (is_array($endringInntekt) && empty($endringInntekt))) {
            unset($this->EndringInntekt);
        } else {
            $this->EndringInntekt = $endringInntekt;
        }
        return $this;
    }
    /**
     * Get Skatt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSkatt()
    {
        return isset($this->Skatt) ? $this->Skatt : null;
    }
    /**
     * Set Skatt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $skatt
     * @return \StructType\OkonomiEnk
     */
    public function setSkatt($skatt = 0)
    {
        // validation for constraint: int
        if (!is_null($skatt) && !is_numeric($skatt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skatt)), __LINE__);
        }
        if (is_null($skatt) || (is_array($skatt) && empty($skatt))) {
            unset($this->Skatt);
        } else {
            $this->Skatt = $skatt;
        }
        return $this;
    }
    /**
     * Get SkatteKlasse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSkatteKlasse()
    {
        return isset($this->SkatteKlasse) ? $this->SkatteKlasse : null;
    }
    /**
     * Set SkatteKlasse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $skatteKlasse
     * @return \StructType\OkonomiEnk
     */
    public function setSkatteKlasse($skatteKlasse = '0')
    {
        // validation for constraint: string
        if (!is_null($skatteKlasse) && !is_string($skatteKlasse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($skatteKlasse)), __LINE__);
        }
        if (is_null($skatteKlasse) || (is_array($skatteKlasse) && empty($skatteKlasse))) {
            unset($this->SkatteKlasse);
        } else {
            $this->SkatteKlasse = $skatteKlasse;
        }
        return $this;
    }
    /**
     * Get SkatteKlasseUtl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSkatteKlasseUtl()
    {
        return isset($this->SkatteKlasseUtl) ? $this->SkatteKlasseUtl : null;
    }
    /**
     * Set SkatteKlasseUtl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $skatteKlasseUtl
     * @return \StructType\OkonomiEnk
     */
    public function setSkatteKlasseUtl($skatteKlasseUtl = '0')
    {
        // validation for constraint: string
        if (!is_null($skatteKlasseUtl) && !is_string($skatteKlasseUtl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($skatteKlasseUtl)), __LINE__);
        }
        if (is_null($skatteKlasseUtl) || (is_array($skatteKlasseUtl) && empty($skatteKlasseUtl))) {
            unset($this->SkatteKlasseUtl);
        } else {
            $this->SkatteKlasseUtl = $skatteKlasseUtl;
        }
        return $this;
    }
    /**
     * Get Kommunenr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getKommunenr()
    {
        return isset($this->Kommunenr) ? $this->Kommunenr : null;
    }
    /**
     * Set Kommunenr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $kommunenr
     * @return \StructType\OkonomiEnk
     */
    public function setKommunenr($kommunenr = 0)
    {
        // validation for constraint: int
        if (!is_null($kommunenr) && !is_numeric($kommunenr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($kommunenr)), __LINE__);
        }
        if (is_null($kommunenr) || (is_array($kommunenr) && empty($kommunenr))) {
            unset($this->Kommunenr);
        } else {
            $this->Kommunenr = $kommunenr;
        }
        return $this;
    }
    /**
     * Get KommuneNavn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKommuneNavn()
    {
        return isset($this->KommuneNavn) ? $this->KommuneNavn : null;
    }
    /**
     * Set KommuneNavn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kommuneNavn
     * @return \StructType\OkonomiEnk
     */
    public function setKommuneNavn($kommuneNavn = null)
    {
        // validation for constraint: string
        if (!is_null($kommuneNavn) && !is_string($kommuneNavn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kommuneNavn)), __LINE__);
        }
        if (is_null($kommuneNavn) || (is_array($kommuneNavn) && empty($kommuneNavn))) {
            unset($this->KommuneNavn);
        } else {
            $this->KommuneNavn = $kommuneNavn;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OkonomiEnk
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
