<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OppdaterOvervakningPortefoljeResponse StructType
 * @subpackage Structs
 */
class OppdaterOvervakningPortefoljeResponse extends AbstractStructBase
{
    /**
     * The OvervakningListe
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OvervakningListe[]
     */
    public $OvervakningListe;
    /**
     * The Meldinger
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Meldinger[]
     */
    public $Meldinger;
    /**
     * Constructor method for OppdaterOvervakningPortefoljeResponse
     * @uses OppdaterOvervakningPortefoljeResponse::setOvervakningListe()
     * @uses OppdaterOvervakningPortefoljeResponse::setMeldinger()
     * @param \StructType\OvervakningListe[] $overvakningListe
     * @param \StructType\Meldinger[] $meldinger
     */
    public function __construct(array $overvakningListe = array(), array $meldinger = array())
    {
        $this
            ->setOvervakningListe($overvakningListe)
            ->setMeldinger($meldinger);
    }
    /**
     * Get OvervakningListe value
     * @return \StructType\OvervakningListe[]|null
     */
    public function getOvervakningListe()
    {
        return $this->OvervakningListe;
    }
    /**
     * Set OvervakningListe value
     * @throws \InvalidArgumentException
     * @param \StructType\OvervakningListe[] $overvakningListe
     * @return \StructType\OppdaterOvervakningPortefoljeResponse
     */
    public function setOvervakningListe(array $overvakningListe = array())
    {
        foreach ($overvakningListe as $oppdaterOvervakningPortefoljeResponseOvervakningListeItem) {
            // validation for constraint: itemType
            if (!$oppdaterOvervakningPortefoljeResponseOvervakningListeItem instanceof \StructType\OvervakningListe) {
                throw new \InvalidArgumentException(sprintf('The OvervakningListe property can only contain items of \StructType\OvervakningListe, "%s" given', is_object($oppdaterOvervakningPortefoljeResponseOvervakningListeItem) ? get_class($oppdaterOvervakningPortefoljeResponseOvervakningListeItem) : gettype($oppdaterOvervakningPortefoljeResponseOvervakningListeItem)), __LINE__);
            }
        }
        $this->OvervakningListe = $overvakningListe;
        return $this;
    }
    /**
     * Add item to OvervakningListe value
     * @throws \InvalidArgumentException
     * @param \StructType\OvervakningListe $item
     * @return \StructType\OppdaterOvervakningPortefoljeResponse
     */
    public function addToOvervakningListe(\StructType\OvervakningListe $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OvervakningListe) {
            throw new \InvalidArgumentException(sprintf('The OvervakningListe property can only contain items of \StructType\OvervakningListe, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OvervakningListe[] = $item;
        return $this;
    }
    /**
     * Get Meldinger value
     * @return \StructType\Meldinger[]|null
     */
    public function getMeldinger()
    {
        return $this->Meldinger;
    }
    /**
     * Set Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger[] $meldinger
     * @return \StructType\OppdaterOvervakningPortefoljeResponse
     */
    public function setMeldinger(array $meldinger = array())
    {
        foreach ($meldinger as $oppdaterOvervakningPortefoljeResponseMeldingerItem) {
            // validation for constraint: itemType
            if (!$oppdaterOvervakningPortefoljeResponseMeldingerItem instanceof \StructType\Meldinger) {
                throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($oppdaterOvervakningPortefoljeResponseMeldingerItem) ? get_class($oppdaterOvervakningPortefoljeResponseMeldingerItem) : gettype($oppdaterOvervakningPortefoljeResponseMeldingerItem)), __LINE__);
            }
        }
        $this->Meldinger = $meldinger;
        return $this;
    }
    /**
     * Add item to Meldinger value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldinger $item
     * @return \StructType\OppdaterOvervakningPortefoljeResponse
     */
    public function addToMeldinger(\StructType\Meldinger $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Meldinger) {
            throw new \InvalidArgumentException(sprintf('The Meldinger property can only contain items of \StructType\Meldinger, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Meldinger[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OppdaterOvervakningPortefoljeResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
