<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Rettighetshavere StructType
 * @subpackage Structs
 */
class Rettighetshavere extends AbstractStructBase
{
    /**
     * The Internreferanse
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Internreferanse;
    /**
     * The FodtDato
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FodtDato;
    /**
     * The Navn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Navn;
    /**
     * The Adresse
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Adresse;
    /**
     * The Postnr
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Postnr;
    /**
     * The Poststed
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Poststed;
    /**
     * The Andel
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $Andel;
    /**
     * The IndirekteEier
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IndirekteEier;
    /**
     * The Landkode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Landkode;
    /**
     * Constructor method for Rettighetshavere
     * @uses Rettighetshavere::setInternreferanse()
     * @uses Rettighetshavere::setFodtDato()
     * @uses Rettighetshavere::setNavn()
     * @uses Rettighetshavere::setAdresse()
     * @uses Rettighetshavere::setPostnr()
     * @uses Rettighetshavere::setPoststed()
     * @uses Rettighetshavere::setAndel()
     * @uses Rettighetshavere::setIndirekteEier()
     * @uses Rettighetshavere::setLandkode()
     * @param int $internreferanse
     * @param string $fodtDato
     * @param string $navn
     * @param string $adresse
     * @param int $postnr
     * @param string $poststed
     * @param float $andel
     * @param bool $indirekteEier
     * @param string $landkode
     */
    public function __construct($internreferanse = 0, $fodtDato = null, $navn = null, $adresse = null, $postnr = 0, $poststed = null, $andel = 0, $indirekteEier = false, $landkode = null)
    {
        $this
            ->setInternreferanse($internreferanse)
            ->setFodtDato($fodtDato)
            ->setNavn($navn)
            ->setAdresse($adresse)
            ->setPostnr($postnr)
            ->setPoststed($poststed)
            ->setAndel($andel)
            ->setIndirekteEier($indirekteEier)
            ->setLandkode($landkode);
    }
    /**
     * Get Internreferanse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getInternreferanse()
    {
        return isset($this->Internreferanse) ? $this->Internreferanse : null;
    }
    /**
     * Set Internreferanse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $internreferanse
     * @return \StructType\Rettighetshavere
     */
    public function setInternreferanse($internreferanse = 0)
    {
        // validation for constraint: int
        if (!is_null($internreferanse) && !is_numeric($internreferanse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($internreferanse)), __LINE__);
        }
        if (is_null($internreferanse) || (is_array($internreferanse) && empty($internreferanse))) {
            unset($this->Internreferanse);
        } else {
            $this->Internreferanse = $internreferanse;
        }
        return $this;
    }
    /**
     * Get FodtDato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFodtDato()
    {
        return isset($this->FodtDato) ? $this->FodtDato : null;
    }
    /**
     * Set FodtDato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fodtDato
     * @return \StructType\Rettighetshavere
     */
    public function setFodtDato($fodtDato = null)
    {
        // validation for constraint: string
        if (!is_null($fodtDato) && !is_string($fodtDato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fodtDato)), __LINE__);
        }
        if (is_null($fodtDato) || (is_array($fodtDato) && empty($fodtDato))) {
            unset($this->FodtDato);
        } else {
            $this->FodtDato = $fodtDato;
        }
        return $this;
    }
    /**
     * Get Navn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNavn()
    {
        return isset($this->Navn) ? $this->Navn : null;
    }
    /**
     * Set Navn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $navn
     * @return \StructType\Rettighetshavere
     */
    public function setNavn($navn = null)
    {
        // validation for constraint: string
        if (!is_null($navn) && !is_string($navn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($navn)), __LINE__);
        }
        if (is_null($navn) || (is_array($navn) && empty($navn))) {
            unset($this->Navn);
        } else {
            $this->Navn = $navn;
        }
        return $this;
    }
    /**
     * Get Adresse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdresse()
    {
        return isset($this->Adresse) ? $this->Adresse : null;
    }
    /**
     * Set Adresse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $adresse
     * @return \StructType\Rettighetshavere
     */
    public function setAdresse($adresse = null)
    {
        // validation for constraint: string
        if (!is_null($adresse) && !is_string($adresse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($adresse)), __LINE__);
        }
        if (is_null($adresse) || (is_array($adresse) && empty($adresse))) {
            unset($this->Adresse);
        } else {
            $this->Adresse = $adresse;
        }
        return $this;
    }
    /**
     * Get Postnr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPostnr()
    {
        return isset($this->Postnr) ? $this->Postnr : null;
    }
    /**
     * Set Postnr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $postnr
     * @return \StructType\Rettighetshavere
     */
    public function setPostnr($postnr = 0)
    {
        // validation for constraint: int
        if (!is_null($postnr) && !is_numeric($postnr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($postnr)), __LINE__);
        }
        if (is_null($postnr) || (is_array($postnr) && empty($postnr))) {
            unset($this->Postnr);
        } else {
            $this->Postnr = $postnr;
        }
        return $this;
    }
    /**
     * Get Poststed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPoststed()
    {
        return isset($this->Poststed) ? $this->Poststed : null;
    }
    /**
     * Set Poststed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $poststed
     * @return \StructType\Rettighetshavere
     */
    public function setPoststed($poststed = null)
    {
        // validation for constraint: string
        if (!is_null($poststed) && !is_string($poststed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($poststed)), __LINE__);
        }
        if (is_null($poststed) || (is_array($poststed) && empty($poststed))) {
            unset($this->Poststed);
        } else {
            $this->Poststed = $poststed;
        }
        return $this;
    }
    /**
     * Get Andel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getAndel()
    {
        return isset($this->Andel) ? $this->Andel : null;
    }
    /**
     * Set Andel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $andel
     * @return \StructType\Rettighetshavere
     */
    public function setAndel($andel = 0)
    {
        if (is_null($andel) || (is_array($andel) && empty($andel))) {
            unset($this->Andel);
        } else {
            $this->Andel = $andel;
        }
        return $this;
    }
    /**
     * Get IndirekteEier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIndirekteEier()
    {
        return isset($this->IndirekteEier) ? $this->IndirekteEier : null;
    }
    /**
     * Set IndirekteEier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $indirekteEier
     * @return \StructType\Rettighetshavere
     */
    public function setIndirekteEier($indirekteEier = false)
    {
        // validation for constraint: boolean
        if (!is_null($indirekteEier) && !is_bool($indirekteEier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($indirekteEier)), __LINE__);
        }
        if (is_null($indirekteEier) || (is_array($indirekteEier) && empty($indirekteEier))) {
            unset($this->IndirekteEier);
        } else {
            $this->IndirekteEier = $indirekteEier;
        }
        return $this;
    }
    /**
     * Get Landkode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLandkode()
    {
        return isset($this->Landkode) ? $this->Landkode : null;
    }
    /**
     * Set Landkode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $landkode
     * @return \StructType\Rettighetshavere
     */
    public function setLandkode($landkode = null)
    {
        // validation for constraint: string
        if (!is_null($landkode) && !is_string($landkode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($landkode)), __LINE__);
        }
        if (is_null($landkode) || (is_array($landkode) && empty($landkode))) {
            unset($this->Landkode);
        } else {
            $this->Landkode = $landkode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Rettighetshavere
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
