<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Scorevariabel StructType
 * @subpackage Structs
 */
class Scorevariabel extends AbstractStructBase
{
    /**
     * The Navn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Navn;
    /**
     * The Verdi
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Verdi;
    /**
     * The Scorepoeng
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Scorepoeng;
    /**
     * Constructor method for Scorevariabel
     * @uses Scorevariabel::setNavn()
     * @uses Scorevariabel::setVerdi()
     * @uses Scorevariabel::setScorepoeng()
     * @param string $navn
     * @param string $verdi
     * @param int $scorepoeng
     */
    public function __construct($navn = null, $verdi = null, $scorepoeng = null)
    {
        $this
            ->setNavn($navn)
            ->setVerdi($verdi)
            ->setScorepoeng($scorepoeng);
    }
    /**
     * Get Navn value
     * @return string|null
     */
    public function getNavn()
    {
        return $this->Navn;
    }
    /**
     * Set Navn value
     * @param string $navn
     * @return \StructType\Scorevariabel
     */
    public function setNavn($navn = null)
    {
        // validation for constraint: string
        if (!is_null($navn) && !is_string($navn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($navn)), __LINE__);
        }
        $this->Navn = $navn;
        return $this;
    }
    /**
     * Get Verdi value
     * @return string|null
     */
    public function getVerdi()
    {
        return $this->Verdi;
    }
    /**
     * Set Verdi value
     * @param string $verdi
     * @return \StructType\Scorevariabel
     */
    public function setVerdi($verdi = null)
    {
        // validation for constraint: string
        if (!is_null($verdi) && !is_string($verdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($verdi)), __LINE__);
        }
        $this->Verdi = $verdi;
        return $this;
    }
    /**
     * Get Scorepoeng value
     * @return int|null
     */
    public function getScorepoeng()
    {
        return $this->Scorepoeng;
    }
    /**
     * Set Scorepoeng value
     * @param int $scorepoeng
     * @return \StructType\Scorevariabel
     */
    public function setScorepoeng($scorepoeng = null)
    {
        // validation for constraint: int
        if (!is_null($scorepoeng) && !is_numeric($scorepoeng)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($scorepoeng)), __LINE__);
        }
        $this->Scorepoeng = $scorepoeng;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Scorevariabel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
