<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VervData StructType
 * @subpackage Structs
 */
class VervData extends AbstractStructBase
{
    /**
     * The VervKode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VervKode;
    /**
     * The VervTekst
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VervTekst;
    /**
     * Constructor method for VervData
     * @uses VervData::setVervKode()
     * @uses VervData::setVervTekst()
     * @param string $vervKode
     * @param string $vervTekst
     */
    public function __construct($vervKode = null, $vervTekst = null)
    {
        $this
            ->setVervKode($vervKode)
            ->setVervTekst($vervTekst);
    }
    /**
     * Get VervKode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVervKode()
    {
        return isset($this->VervKode) ? $this->VervKode : null;
    }
    /**
     * Set VervKode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vervKode
     * @return \StructType\VervData
     */
    public function setVervKode($vervKode = null)
    {
        // validation for constraint: string
        if (!is_null($vervKode) && !is_string($vervKode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vervKode)), __LINE__);
        }
        if (is_null($vervKode) || (is_array($vervKode) && empty($vervKode))) {
            unset($this->VervKode);
        } else {
            $this->VervKode = $vervKode;
        }
        return $this;
    }
    /**
     * Get VervTekst value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVervTekst()
    {
        return isset($this->VervTekst) ? $this->VervTekst : null;
    }
    /**
     * Set VervTekst value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vervTekst
     * @return \StructType\VervData
     */
    public function setVervTekst($vervTekst = null)
    {
        // validation for constraint: string
        if (!is_null($vervTekst) && !is_string($vervTekst)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vervTekst)), __LINE__);
        }
        if (is_null($vervTekst) || (is_array($vervTekst) && empty($vervTekst))) {
            unset($this->VervTekst);
        } else {
            $this->VervTekst = $vervTekst;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VervData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
